# R sample script for Dr.Hatada@@
# Fuunction:Lm Prot from Ajilent Scanner Export data
# Copyright (C) 2007 DYNACOM Co.,Ltd.
# Author Y.Aoki (2007.02)
#

#

memory.limit(size=2048);

cat(date(), "\n\n");

cat("Current working directory is :", getwd(), "\n");
cat("Change directory to your data folder by file menu and press enter.");
readline();
cat("Current working directory is :", getwd(), "\n");

fa = readline("Input file name(A): ");
fb = readline("Input file name(B): ");
cat("fname(A):", fa, " fname(B):", fb, "\n");


cat("Input a name added to output files: ");
add_str=readline();
cat("Name added to output files:", add_str, "\n");
cat(date(), "\n\n");

a0=read.delim(fa, skip=9, header=TRUE);
b0=read.delim(fb, skip=9, header=TRUE);
#a0=read.delim("251509510015_A.txt", skip=9, header=TRUE);
#b0=read.delim("251509510015_B.txt", skip=9, header=TRUE);


a1=data.frame(Col=a0$Col, Row=a0$Row,  FeatureNum=a0$FeatureNum,
        ProbeName=a0$ProbeName, GeneName=a0$GeneName,  
        gProcessedSignal_A=a0$gProcessedSignal, rProcessedSignal_A=a0$rProcessedSignal, 
        Flags_A=a0$gIsFeatNonUnifOL+a0$rIsFeatNonUnifOL, 
        ProbeUID=a0$ProbeUID, ControlType=a0$ControlType, SystematicName=a0$SystematicName, 
	Description=a0$Description, PValueA=a0$PValueLogRatio);

a1p = data.frame(Col=a0$Col, Row=a0$Row, ProbeName=a0$ProbeName,
	ag=a0$gProcessedSignal, ar=b0$rProcessedSignal,
	gIs=a0$gIsFeatNonUnifOL, rIs=a0$rIsFeatNonUnifOL, ControlType=a0$ControlType);

b1=data.frame(Col=b0$Col, Row=b0$Row,   
       gProcessedSignal_B=b0$gProcessedSignal, rProcessedSignal_B=b0$rProcessedSignal,
       Flags_B=b0$gIsFeatNonUnifOL+b0$rIsFeatNonUnifOL, PValueB=b0$PValueLogRatio);

c0=merge(a1, b1);

c1 = c0[c(1, 2, 3, 4, 5, 6, 7, 14, 15, 8, 16, 10, 9, 11, 12, 13, 17)];
c2 = subset(c1, Flags_A==0&Flags_B==0&ControlType==0);
cat(fa, "has ", nrow(a1), "lines, ", fb, "has ", nrow(b1), "lines.\n");
cat("After merge and selecting(Flags, ControlType) process, ", nrow(c2), "lines remained.\n");
cat(date(),"\n\n"); 

#Omit Double or Triple Row & Get Correlation factor
c7 = c2;
c7_sl1 = order(c7$ProbeName, as.integer(c7$FeatureNum));
c7s=c7[c7_sl1,];

d1 = c7s$ProbeName;
rSigA_c7s = c7s$rProcessedSignal_A;
gSigA_c7s = c7s$gProcessedSignal_A;
rSigB_c7s = c7s$rProcessedSignal_B;
gSigB_c7s = c7s$gProcessedSignal_B;

i=1;
fn_c = 0;
max_fn_cnt = 0;
d1n=nrow(c7s);
j=1;
ar1 = c(0);
ar2 = ar1;
ar3 = ar1;
ag1 = c(0);
ag2 = ag1;
ag3 = ag1;

br1 = c(0);
br2 = br1;
br3 = br1;
bg1 = c(0);
bg2 = bg1;
bg3 = bg1;
fn_cnt = c(0);
id_rg = c(0);

i = d1n + 1;

while (i <= d1n) {
	if (i < d1n && identical(d1[i], d1[i + 1])) {
		ar1[j] = rSigA_c7s[i];
		ag1[j] = gSigA_c7s[i];
		br1[j] = rSigB_c7s[i];
		bg1[j] = gSigB_c7s[i];
		id_rg[j] = as.character(d1[i+1]);		
		if (i < d1n - 1 && identical(d1[i + 1], d1[i + 2])) {
				ar2[j] = rSigA_c7s[i+1];
				ag2[j] = gSigA_c7s[i+1];
				br2[j] = rSigB_c7s[i+1];
				bg2[j] = gSigB_c7s[i+1];
				ar3[j] = rSigA_c7s[i+2];
				ag3[j] = gSigA_c7s[i+2];
				br3[j] = rSigB_c7s[i+2];
				bg3[j] = gSigB_c7s[i+2];
				fn_cnt[j] = 3;
				fn_c = 3;
		} else {
				ar2[j] = rSigA_c7s[i+1];
				ag2[j] = gSigA_c7s[i+1];
				br2[j] = rSigB_c7s[i+1];
				bg2[j] = gSigB_c7s[i+1];
				fn_cnt[j] = 2;
				fn_c = 2;
		}
		i = i + fn_c;
		if (max_fn_cnt < fn_c) {
			max_fn_cnt = fn_c;
		}	
		j = j + 1;

	} else {
		i = i + 1;
	}
}
cat("Finish the process omit double or triple lines\n");
cat(date(),"\n\n");

if (max_fn_cnt == 2) {
	crd1 = data.frame(ProbeName=id_rg, fn_cnt=fn_cnt,
		AG1=ag1, AG2=ag2, AR1=ar1, AR2=ar2,
		BG1=bg1, BG2=bg2, BR1=br1, BR2=br2);
	crd1s = subset(crd1, fn_cnt == max_fn_cnt);
	ag1 = crd1s$AG1;
	ag2 = crd1s$AG2;
	ar1 = crd1s$AR1;
	ar2 = crd1s$AR2;
	bg1 = crd1s$BG1;
	bg2 = crd1s$BG2;
	br1 = crd1s$BR1;
	br2 = crd1s$BR2;	
} else if (max_fn_cnt == 3) {
	crd1 = data.frame(ProbeName=id_rg, fn_cnt=fn_cnt,
		AG1=ag1, AG2=ag2, AG3=ag3, AR1=ar1, AR2=ar2, AR3=ar3,
		BG1=bg1, BG2=bg2, BG3=bg3, BR1=br1, BR2=br2, BR3=br3);
	crd1s = subset(crd1, fn_cnt == max_fn_cnt);
	ag1 = crd1s$AG1;
	ag2 = crd1s$AG2;
	ag3 = crd1s$AG3;
	ar1 = crd1s$AR1;
	ar2 = crd1s$AR2;
	ar3 = crd1s$AR3;
	bg1 = crd1s$BG1;
	bg2 = crd1s$BG2;
	bg3 = crd1s$BG3;
	br1 = crd1s$BR1;
	br2 = crd1s$BR2;
	br3 = crd1s$BR3;
}


c2$rProcessedSignal_A<-ifelse(c2$rProcessedSignal_A<1, 1, c2$rProcessedSignal_A);
c2$gProcessedSignal_A<-ifelse(c2$gProcessedSignal_A<1, 1, c2$gProcessedSignal_A);
c2$rProcessedSignal_B<-ifelse(c2$rProcessedSignal_B<1, 1, c2$rProcessedSignal_B);
c2$gProcessedSignal_B<-ifelse(c2$gProcessedSignal_B<1, 1, c2$gProcessedSignal_B);

c3A=data.frame(Cy3A=c2$gProcessedSignal_A);
c5A=data.frame(Cy5A=c2$rProcessedSignal_A);
c3B=data.frame(Cy3B=c2$gProcessedSignal_B);
c5B=data.frame(Cy5B=c2$rProcessedSignal_B);

n = nrow(c3A);

cy3a_s=sum(c3A$Cy3A);
cy5a_s=sum(c5A$Cy5A);
cy3b_s=sum(c3B$Cy3B);
cy5b_s=sum(c5B$Cy5B);

cy3a_ave=cy3a_s/n;
cy5a_ave=cy5a_s/n;
cy3b_ave=cy3b_s/n;
cy5b_ave=cy5b_s/n;

c3A$Cy3A=(c3A$Cy3A/cy3a_ave)*100;
c5A$Cy5A=(c5A$Cy5A/cy5a_ave)*100;
c3B$Cy3B=(c3B$Cy3B/cy3b_ave)*100;
c5B$Cy5B=(c5B$Cy5B/cy5b_ave)*100;

cy3a_s=sum(c3A$Cy3A)
cy5a_s=sum(c5A$Cy5A)
cy3b_s=sum(c3B$Cy3B)
cy5b_s=sum(c5B$Cy5B)

sl3A=order(c3A$Cy3A, decreasing=TRUE);s3a=c3A[sl3A,];
sl5A=order(c5A$Cy5A, decreasing=TRUE);s5a=c5A[sl5A,];
sl3B=order(c3B$Cy3B, decreasing=TRUE);s3b=c3B[sl3B,];
sl5B=order(c5B$Cy5B, decreasing=TRUE);s5b=c5B[sl5B,];

i=1;
tmp_3a=0;
while (i<=n) {
	if (tmp_3a + s3a[i]>0.5*cy3a_s) {
		break;
	}
	tmp_3a=tmp_3a+s3a[i];
	i=i+1;
}
i_3a=i;

i=1;
tmp_5a=0;
while (i<=n) {
	if (tmp_5a + s5a[i]>0.5*cy5a_s) {
		break;
	}
	tmp_5a=tmp_5a+s5a[i];
	i=i+1;
}
i_5a=i;

i=1;
tmp_3b=0;
while (i<=n) {
	if (tmp_3b + s3b[i]>0.5*cy3b_s) {
		break;
	}
	tmp_3b=tmp_3b+s3b[i];
	i=i+1;
}
i_3b=i;

i=1;
tmp_5b=0;
while (i<=n) {
	if (tmp_5b + s5b[i]>0.5*cy5b_s) {
		break;
	}
	tmp_5b=tmp_5b+s5b[i];
	i=i+1;
}
i_5b=i;


i=1;
sum50_c3A=0;
while (i <= i_3a) {
	sum50_c3A = sum50_c3A + s3a[i];
	i=i+1;
}

i=1;
sum50_c5A=0;
while (i <= i_5a) {
	sum50_c5A = sum50_c5A + s5a[i];
	i=i+1;
}

i=1;
sum50_c3B=0;
while (i <= i_3b) {
	sum50_c3B = sum50_c3B + s3b[i];
	i=i+1;
}

i=1;
sum50_c5B=0;
while (i <= i_5b) {
	sum50_c5B = sum50_c5B + s5b[i];
	i=i+1;
}

cat("sum50:", sum50_c3A, sum50_c5A, sum50_c3B, sum50_c5B, "\n");
cat(date(),"\n\n");

ave50_c3A=sum50_c3A/i_3a;
ave50_c5A=sum50_c5A/i_5a;
ave50_c3B=sum50_c3B/i_3b;
ave50_c5B=sum50_c5B/i_5b;
cat("ave50:", ave50_c3A, ave50_c5A, ave50_c3B, ave50_c5B, "\n");


th_rate=5;
if (is.na(th_rate)) {
	TH_3A=ave50_c3A;
	TH_5A=ave50_c5A;
	TH_3B=ave50_c3B;
	TH_5B=ave50_c5B;
} else {

	TH_3A=(ave50_c3A*th_rate)/100;
	TH_5A=(ave50_c5A*th_rate)/100;
	TH_3B=(ave50_c3B*th_rate)/100;
	TH_5B=(ave50_c5B*th_rate)/100;
}

cat("TH:", TH_3A, TH_5A, TH_3B, TH_5B, "\n");

c21 = data.frame(Col=c2$Col, Row=c2$Row, c3A, c5A, c3B, c5B); 
c22 = subset(c21, c21$Cy3A > TH_3A | c21$Cy5A > TH_5A);
c3 =  subset(c22, c22$Cy3B > TH_3B | c22$Cy5B > TH_5B);


c4 = data.frame(
	Col=c3$Col, Row=c3$Row,
	Cy3A=c3$Cy3A, 
	Cy5A=c3$Cy5A,
	Cy3B=c3$Cy3B,
	Cy5B=c3$Cy5B,
	A=(c3$Cy3A / c3$Cy5A),
	B=(c3$Cy3B / c3$Cy5B)
);


Alog10 = log10(c4$A);
Blog10 = log10(c4$B);
logA = Alog10;
logB = Blog10;
plot(logA, logB);
#plot(Alog10, Blog10);

ab_rate=data.frame(abr=c4$A/c4$B);
sl_ab=order(ab_rate$abr);sab_rate=ab_rate[sl_ab,];
p1 = as.integer(nrow(ab_rate) * 0.2);
p2 = as.integer(nrow(ab_rate) * 0.8);
ab_min = sab_rate[p1];
ab_max = sab_rate[p2];
cat("ab_min:", ab_min, " ab_max:", ab_max, "\n");

c5 = subset(c4, A/B>ab_min&A/B<ab_max);
Alog10 = log10(c5$A);
Blog10 = log10(c5$B);

c5 = transform(c5, logA=Alog10, logB=Blog10);

c51 = data.frame(Alog10=Alog10, Blog10=Blog10);
c5_lm <- lm(formula=Blog10~Alog10, data=c51);

coefficients(c5_lm);
co=data.frame(coefficients(c5_lm))
a=co[2,1];
b=co[1,1];
cat("a:", a, " b:", b, "\n");

c5 = transform(c5, DRL=c5$logA - (c5$logB - b) / a);

drl =data.frame(DRL=((log10(c4$B)-b)/a), D10=0);
drl$DRL=(log10(c4$A) - drl$DRL);
drl$D10=10^(drl$DRL);

c4_log = data.frame(LOG_A=log10(c4$A), LOG_B=log10(c4$B));

c6=data.frame(
	Col=c4$Col, Row=c4$Row,
	Cy3A=c4$Cy3A, Cy5A=c4$Cy5A,
	Cy3B=c4$Cy3B, Cy5B=c4$Cy5B,
	A=c4$A, B=c4$B, logA=c4_log$LOG_A, logB=c4_log$LOG_B,
	DRL=drl$DRL, D10=drl$D10, judge=2);

Ac=5;
Bc=2;
Dc=5;

cat("Ac:", Ac, " Bc:", Bc, " Dc:", Dc, "\n");

i = 1;
cnt = 1;
n6 = nrow(c6);
jd = c6$judge;
av = c6$A;
lbv = c6$logB;
d10v = c6$D10;

while (i <= n6) {
	jval = jd[i];
	if (jval != 0 && is.na(Ac)==FALSE) {
		if (av[i] > Ac) {
			jval = 1;
		} else if (av[i] < 1/Ac) {
			jval = -1;
		} else {
			jval = 0;
		}
	}
	if (jval != 0 && is.na(Bc)==FALSE) {
		if (abs(lbv[i]) >= log10(Bc)) {
			jval = 0;
		}
	}
	if (jval != 0 && is.na(Dc)==FALSE) {
		if (jval == 2) {
			if (d10v[i] > Dc) { 
				jval = 1;
			} else if (d10v[i] < 1/Dc) {
				jval = -1;
			} else {
				jval = 0;
			}
		} else if (jval == 1) {
			if (d10v[i] <= Dc) {
				jval = 0;
			}
		} else if (jval == -1) {
			if (d10v[i] >= 1/Dc) {
				jval = 0;
			}
		}
	}
	if (jval == 2) {
		jval = 0;
	}
	jd[i] = jval;
	if (i == cnt * 3000) {
		cat(i, "entry processed.\n");
		cnt = cnt + 1;
	}	
	i = i + 1;
}
c6$judge = jd;

c7 = merge(c2, c6);
c7_sl = order(c7$ProbeName, as.integer(c7$FeatureNum));
c71 = c7[c7_sl,];
c7 = c71;

cat("Finish the calculations for hyper, hypo\n");
cat(date(),"\n\n");


i = 1;
pn = c7$ProbeName;
nc7 = nrow(c7);

i = nc7 + 1;

while (i <= nc7) {
	if (i < nc7 && identical(pn[i], pn[i + 1])) {
		pn[i] = NA;
		i = i + 1;
		if (i < nc7 - 1 && identical(pn[i], pn[i + 1])) {
			pn[i] = NA;
			i = i + 1;
		}
	}
	i = i + 1;
}
c7$ProbeName = pn;
c71 = subset(c7, is.na(c7$ProbeName)==FALSE);

res_fn=paste(add_str, "Res.txt", sep="");
write.table(c71, res_fn, sep="\t", quote=F, col.names=T, append=F, row.names=F);


c8 = subset(c71, c71$judge==1);
hyper_fn=paste(add_str, "Hyper.txt", sep="");
write.table(c8, hyper_fn, sep="\t", quote=F, col.names=T, append=F, row.names=F);

c9 = subset(c71, c71$judge==-1);
hypo_fn=paste(add_str, "Hypo.txt", sep="");
write.table(c9, hypo_fn, sep="\t", quote=F, col.names=T, append=F, row.names=F);
nc71 = nrow(c71);
nc8 = nrow(c8);
nc9 = nrow(c9);

cat("Res:", nc71, " ", " Hyper:", nc8, " Hypo:", nc9, " finished.\n");

i = 1;
w8 = c8$SystematicName;
w10=c(0);
w11=c(0);
w12=c(0);
w10[1] = "track";
w11[1] = "name=Hypermethylated";
w12[1] = "color=255,0,0";
while (i <= nc8) {
	w1 = data.frame(strsplit(as.character(w8[i]), ":"));
	w2 = data.frame(strsplit(as.character(w1[2,]), "-"));
	w10[i+1] = as.character(w1[1,]);
	w11[i+1] = as.character(w2[1,]);
	w12[i+1] = as.character(w2[2,]);
	i = i + 1;
}
w10[i+1] = "";
w11[i+1] = "";
w12[i+1] = "";
w9 = data.frame(v1=w10, v2=w11, v3=w12);
ucsc_fn=paste(add_str, "UCSC.txt", sep="");
write.table(w9, ucsc_fn, sep="\t", quote=F, col.names=F, append=F, row.names=F);

i = 1;
w8 = c9$SystematicName;
w10=c(0);
w11=c(0);
w12=c(0);
w10[1] = "track";
w11[1] = "name=Hypomethylated";
w12[1] = "color=0,0,255";
while (i <= nc9) {
	w1 = data.frame(strsplit(as.character(w8[i]), ":"));
	w2 = data.frame(strsplit(as.character(w1[2,]), "-"));
	w10[i+1] = as.character(w1[1,]);
	w11[i+1] = as.character(w2[1,]);
	w12[i+1] = as.character(w2[2,]);
	i = i + 1;
}
w9 = data.frame(v1=w10, v2=w11, v3=w12);

write.table(w9, ucsc_fn, sep="\t", quote=F, col.names=F, append=T, row.names=F);
cat("UCSC:", nc8+nc9, "finished.\n");

statics_fn=paste(add_str, "Statics.txt", sep="");
cat("Input File(A):", fa, "\n", file=statics_fn, append=F);
cat("Input File(B):", fb, "\n", file=statics_fn, append=T);
if (max_fn_cnt >= 2) {
	cat("Correlation Factor(gProcessedSignal_A(1-2):", cor(ag1, ag2), "\n", file=statics_fn, append=T);
	cat("Correlation Factor(rProcessedSignal_A(1-2):", cor(ar1, ar2), "\n", file=statics_fn, append=T);
	cat("Correlation Factor(gProcessedSignal_B(1-2):", cor(bg1, bg2), "\n", file=statics_fn, append=T);
	cat("Correlation Factor(rProcessedSignal_B(1-2):", cor(br1, br2), "\n", file=statics_fn, append=T);
	if (max_fn_cnt == 3) {
		cat("Correlation Factor(gProcessedSignal_A(2-3):", cor(ag2, ag3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(rProcessedSignal_A(2-3):", cor(ar2, ar3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(gProcessedSignal_B(2-3):", cor(bg2, bg3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(rProcessedSignal_B(2-3):", cor(br2, br3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(gProcessedSignal_A(1-3):", cor(ag1, ag3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(rProcessedSignal_A(1-3):", cor(ar1, ar3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(gProcessedSignal_B(1-3):", cor(bg1, bg3), "\n", file=statics_fn, append=T);
		cat("Correlation Factor(rProcessedSignal_B(1-3):", cor(br1, br3), "\n", file=statics_fn, append=T);
	}
} else {
	cat("Correlation Factor is none.\n", file=statics_fn, append=T);
}
cat("sum50:", sum50_c3A, sum50_c5A, sum50_c3B, sum50_c5B, "\n", file=statics_fn, append=T);
cat("TH rate(%):", th_rate, "\n", file=statics_fn, append=T);
cat("TH:", TH_3A, TH_5A, TH_3B, TH_5B, "\n", file=statics_fn, append=T);
cat("ab_min:", ab_min, " ab_max:", ab_max, "\n", file=statics_fn, append=T);
cat("Ac:", Ac, " Bc:", Bc, " Dc:", Dc, "\n", file=statics_fn, append=T);
cat("Coeffients a:", a, " b:", b, "\n", file=statics_fn, append=T);
cat("Judge count all:", nc71, " Hyper:", nc8, " Hypo:", nc9, "\n", file=statics_fn, append=T);

cat("R process all finished.\n");
cat(date(), "\n\n");
